//CPU disassemble

#ifndef __XATREMU_CPU8040__
#define __XATREMU_CPU8040__

namespace xatremu
{
class CPU8040
{
public:
	CPU8040();
	~CPU8040();
	//disassemble next instruction in program memory
	void DisAsmNextInstruction();

private:
	//table with instruction emulation subroutines
	typedef void (CPU8040::* CPUFunc)(void);
	CPUFunc CPUFuncTable[256];

private:
	unsigned short r_PC;
	//unsigned char r_R0, r_R1, r_R2, r_R3, r_R4, r_R5, r_R6, r_R7;
	//unsigned int64 totalCycles;
	//unsigned char r_A, r_B;
	//bool r_C;
	void *instrMemPtr;
	unsigned long ROMLen;

	void I_ADD_A_AT_R0(void);
	void I_ADD_A_AT_R1(void);
	void I_ADD_A_IMM(void);
	void I_ADD_A_R0(void);
	void I_ADD_A_R1(void);
	void I_ADD_A_R2(void);
	void I_ADD_A_R3(void);
	void I_ADD_A_R4(void);
	void I_ADD_A_R5(void);
	void I_ADD_A_R6(void);
	void I_ADD_A_R7(void);
	void I_ADDC_A_AT_R0(void);
	void I_ADDC_A_AT_R1(void);
	void I_ADDC_A_IMM(void);
	void I_ADDC_A_R0(void);
	void I_ADDC_A_R1(void);
	void I_ADDC_A_R2(void);
	void I_ADDC_A_R3(void);
	void I_ADDC_A_R4(void);
	void I_ADDC_A_R5(void);
	void I_ADDC_A_R6(void);
	void I_ADDC_A_R7(void);
	void I_ANL_A_AT_R0(void);
	void I_ANL_A_AT_R1(void);
	void I_ANL_A_IMM(void);
	void I_ANL_A_R0(void);
	void I_ANL_A_R1(void);
	void I_ANL_A_R2(void);
	void I_ANL_A_R3(void);
	void I_ANL_A_R4(void);
	void I_ANL_A_R5(void);
	void I_ANL_A_R6(void);
	void I_ANL_A_R7(void);
	void I_ANL_BUS_IMM(void);
	void I_ANL_P1_IMM(void);
	void I_ANL_P2_IMM(void);
	void I_ANLD_P4_A(void);
	void I_ANLD_P5_A(void);
	void I_ANLD_P6_A(void);
	void I_ANLD_P7_A(void);
	void I_CALL_CODE(void);
	void I_CLR_A(void);
	void I_CLR_C(void);
	void I_CLR_F0(void);
	void I_CLR_F1(void);
	void I_CPL_A(void);
	void I_CPL_C(void);
	void I_CPL_F0(void);
	void I_CPL_F1(void);
	void I_DA_A(void);
	void I_DEC_A(void);
	void I_DEC_R0(void);
	void I_DEC_R1(void);
	void I_DEC_R2(void);
	void I_DEC_R3(void);
	void I_DEC_R4(void);
	void I_DEC_R5(void);
	void I_DEC_R6(void);
	void I_DEC_R7(void);
	void I_DIS_I(void);
	void I_DIS_TCNTI(void);
	void I_DJNZ_R0_CODE(void);
	void I_DJNZ_R1_CODE(void);
	void I_DJNZ_R2_CODE(void);
	void I_DJNZ_R3_CODE(void);
	void I_DJNZ_R4_CODE(void);
	void I_DJNZ_R5_CODE(void);
	void I_DJNZ_R6_CODE(void);
	void I_DJNZ_R7_CODE(void);
	void I_EN_I(void);
	void I_EN_TCNTI(void);
	void I_ENT0_CLK(void);
	void I_IN_A_P1(void);
	void I_IN_A_P2(void);
	void I_INC_A(void);
	void I_INC_AT_R0(void);
	void I_INC_AT_R1(void);
	void I_INC_R0(void);
	void I_INC_R1(void);
	void I_INC_R2(void);
	void I_INC_R3(void);
	void I_INC_R4(void);
	void I_INC_R5(void);
	void I_INC_R6(void);
	void I_INC_R7(void);
	void I_INS_A_BUS(void);
	void I_JB0_CODE(void);
	void I_JB1_CODE(void);
	void I_JB2_CODE(void);
	void I_JB3_CODE(void);
	void I_JB4_CODE(void);
	void I_JB5_CODE(void);
	void I_JB6_CODE(void);
	void I_JB7_CODE(void);
	void I_JC_CODE(void);
	void I_JF0_CODE(void);
	void I_JF1_CODE(void);
	void I_JMP_CODE(void);
	void I_JMPP_AT_A(void);
	void I_JNC_CODE(void);
	void I_JNI_CODE(void);
	void I_JNT0_CODE(void);
	void I_JNT1_CODE(void);
	void I_JNZ_CODE(void);
	void I_JT0_CODE(void);
	void I_JT1_CODE(void);
	void I_JTF_CODE(void);
	void I_JZ_CODE(void);
	void I_MOV_A_IMM(void);
	void I_MOV_A_AT_R0(void);
	void I_MOV_A_AT_R1(void);
	void I_MOV_A_PSW(void);
	void I_MOV_A_R0(void);
	void I_MOV_A_R1(void);
	void I_MOV_A_R2(void);
	void I_MOV_A_R3(void);
	void I_MOV_A_R4(void);
	void I_MOV_A_R5(void);
	void I_MOV_A_R6(void);
	void I_MOV_A_R7(void);
	void I_MOV_A_T(void);
	void I_MOV_AT_R0_A(void);
	void I_MOV_AT_R1_A(void);
	void I_MOV_AT_R0_IMM(void);
	void I_MOV_AT_R1_IMM(void);
	void I_MOV_PSW_A(void);
	void I_MOV_R0_A(void);
	void I_MOV_R1_A(void);
	void I_MOV_R2_A(void);
	void I_MOV_R3_A(void);
	void I_MOV_R4_A(void);
	void I_MOV_R5_A(void);
	void I_MOV_R6_A(void);
	void I_MOV_R7_A(void);
	void I_MOV_R0_IMM(void);
	void I_MOV_R1_IMM(void);
	void I_MOV_R2_IMM(void);
	void I_MOV_R3_IMM(void);
	void I_MOV_R4_IMM(void);
	void I_MOV_R5_IMM(void);
	void I_MOV_R6_IMM(void);
	void I_MOV_R7_IMM(void);
	void I_MOV_T_A(void);
	void I_MOVD_A_P4(void);
	void I_MOVD_A_P5(void);
	void I_MOVD_A_P6(void);
	void I_MOVD_A_P7(void);
	void I_MOVD_P4_A(void);
	void I_MOVD_P5_A(void);
	void I_MOVD_P6_A(void);
	void I_MOVD_P7_A(void);
	void I_MOVP_A_AT_A(void);
	void I_MOVP3_A_AT_A(void);
	void I_MOVX_A_AT_R0(void);
	void I_MOVX_A_AT_R1(void);
	void I_MOVX_AT_R0_A(void);
	void I_MOVX_AT_R1_A(void);
	void I_NOP(void);
	void I_ORL_A_AT_R0(void);
	void I_ORL_A_AT_R1(void);
	void I_ORL_A_IMM(void);
	void I_ORL_A_R0(void);
	void I_ORL_A_R1(void);
	void I_ORL_A_R2(void);
	void I_ORL_A_R3(void);
	void I_ORL_A_R4(void);
	void I_ORL_A_R5(void);
	void I_ORL_A_R6(void);
	void I_ORL_A_R7(void);
	void I_ORL_BUS_IMM(void);
	void I_ORL_P1_IMM(void);
	void I_ORL_P2_IMM(void);
	void I_ORLD_P4_A(void);
	void I_ORLD_P5_A(void);
	void I_ORLD_P6_A(void);
	void I_ORLD_P7_A(void);
	void I_OUTL_BUS_A(void);
	void I_OUTL_P1_A(void);
	void I_OUTL_P2_A(void);
	void I_RET(void);
	void I_RETR(void);
	void I_RL_A(void);
	void I_RLC_A(void);
	void I_RR_A(void);
	void I_RRC_A(void);
	void I_SEL_MB0(void);
	void I_SEL_MB1(void);
	void I_SEL_RB0(void);
	void I_SEL_RB1(void);
	void I_STOP_TCNT(void);
	void I_STRT_CNT(void);
	void I_STRT_T(void);
	void I_SWAP_A(void);
	void I_UNDEF(void); //new
	void I_XCH_A_AT_R0(void);
	void I_XCH_A_AT_R1(void);
	void I_XCH_A_R0(void);
	void I_XCH_A_R1(void);
	void I_XCH_A_R2(void);
	void I_XCH_A_R3(void);
	void I_XCH_A_R4(void);
	void I_XCH_A_R5(void);
	void I_XCH_A_R6(void);
	void I_XCH_A_R7(void);
	void I_XCHD_A_AT_R0(void);
	void I_XCHD_A_AT_R1(void);
	void I_XRL_A_AT_R0(void);
	void I_XRL_A_AT_R1(void);
	void I_XRL_A_IMM(void);
	void I_XRL_A_R0(void);
	void I_XRL_A_R1(void);
	void I_XRL_A_R2(void);
	void I_XRL_A_R3(void);
	void I_XRL_A_R4(void);
	void I_XRL_A_R5(void);
	void I_XRL_A_R6(void);
	void I_XRL_A_R7(void);

public:
	//set a value in data memory
	//void SetDataMem(unsigned short addr, unsigned char value);
	//get a value from data memory
	//unsigned char GetDataMem(unsigned short addr);
	//set instruction Mem Pointer
	void SetInstrMemPtr(void* ptr);
	//set ROM length
	void SetROMLen(unsigned long len);
	//set instruction pointer
	void SetInstrPtr(unsigned short myPtr);
	//get instruction Pointer
	unsigned short GetInstrPtr();
private:
	//set a value in instruction memory
	//void SetInstrMem(unsigned short addr, unsigned char value); //for testing only
	//get a value from instruction memory
	unsigned char GetInstrMem(unsigned short addr);
	//get/set io-area
	//void SetIOArea(unsigned char bit, bool value);
	//bool GetIOArea(unsigned char bit); 

};
}
#endif
