// management of serial data, CPU-bound, base

#ifndef __XATREMU_SERIAL_BASE__
#define __XATREMU_SERIAL_BASE__

#include "testdefines.h"
#include "cpu8040_base.h"

namespace xatremu
{
class SerialBase
{
public:
	SerialBase();
	virtual ~SerialBase() = 0;
	virtual void SetCPU(CPU8040Base* myCPU);
	virtual void ResetSerial();
	virtual bool StateIntLine();
        virtual void SetIntLineAtari(bool intLine);
	virtual bool StateT0Line();
	virtual void T0NextBit();
	virtual void SerialOutBit(bool outBit);
        virtual void P17NextBit();
	virtual bool ReadyForNextInByte();
	virtual void SerialByteFromAtari(unsigned char A800Byte);
	virtual bool SerialOutByteComplete();
	virtual unsigned char SerialByteToAtari();
	virtual void SetSIOSpeed(unsigned char Speed);

protected:
	signed char m_currentInBit; //0-9;10 is end
	unsigned char m_currentInByte;
	unsigned char m_currentOutBit; //0-9;10 is end
	unsigned char m_currentOutByte;
	unsigned char m_storedOutByte; //if an outbyte is complete, its transferred here
	bool m_storedOutBit; //state of line P1.7
	bool m_storedOutByteOk;
	bool m_stateIntLine; //cause interrupt when SKCTL & 0x70 = 0x20
	unsigned int m_bitcycles; //cycles to wait for a bit
	unsigned int m_waitcycles; //cycles to wait for the additional delay
	unsigned int m_transferbitcycles; //cycles to wait for a bit while transfer
	unsigned int m_transferwaitcycles; //cycles to wait for the additional delay while transfer
	CPU8040Base *m_CPU8040;

private:
	friend class testCPU8040;
};
}
#endif
