//testcpu8040.h
// test 8040 CPU functions

#ifndef __XATREMU_TESTCPU8040__
#define __XATREMU_TESTCPU8040__

#include "cpu8040.h"
#include "rommgmt_mock.h"
#include "wd1772_mock.h"
#include "serial_mock.h"

namespace xatremu
{
class testCPU8040
{
public:
	testCPU8040();
	virtual ~testCPU8040();
	virtual void runTest();

private:
	virtual void testGetInstrMem();
	virtual void testSetInstrMem();
	virtual void test1_I_ADD_A_AT_R0();
	virtual void test2_I_ADD_A_AT_R0();
        virtual void test1_I_ADD_A_AT_R1();
        virtual void test2_I_ADD_A_AT_R1();
        virtual void test1_I_ADD_A_IMM();
        virtual void test2_I_ADD_A_IMM();
	virtual void test1_I_ADD_A_R0();
	virtual void test2_I_ADD_A_R0();
        virtual void test1_I_ADD_A_R1();
        virtual void test2_I_ADD_A_R1();
        virtual void test1_I_ADD_A_R2();
        virtual void test2_I_ADD_A_R2();
        virtual void test1_I_ADD_A_R3();
        virtual void test2_I_ADD_A_R3();
        virtual void test1_I_ADD_A_R4();
        virtual void test2_I_ADD_A_R4();
        virtual void test1_I_ADD_A_R5();
        virtual void test2_I_ADD_A_R5();
        virtual void test1_I_ADD_A_R6();
        virtual void test2_I_ADD_A_R6();
        virtual void test1_I_ADD_A_R7();
        virtual void test2_I_ADD_A_R7();
        virtual void test1_I_ADDC_A_AT_R0();
        virtual void test2_I_ADDC_A_AT_R0();
        virtual void test3_I_ADDC_A_AT_R0();
        virtual void test4_I_ADDC_A_AT_R0();
        virtual void test1_I_ADDC_A_AT_R1();
        virtual void test2_I_ADDC_A_AT_R1();
        virtual void test3_I_ADDC_A_AT_R1();
        virtual void test4_I_ADDC_A_AT_R1();
        virtual void test1_I_ADDC_A_IMM();
        virtual void test2_I_ADDC_A_IMM();
        virtual void test3_I_ADDC_A_IMM();
	virtual void test4_I_ADDC_A_IMM();
        virtual void test1_I_ADDC_A_R0();
        virtual void test2_I_ADDC_A_R0();
        virtual void test3_I_ADDC_A_R0();
	virtual void test4_I_ADDC_A_R0();
        virtual void test1_I_ADDC_A_R1();
        virtual void test2_I_ADDC_A_R1();
        virtual void test3_I_ADDC_A_R1();
	virtual void test4_I_ADDC_A_R1();
        virtual void test1_I_ADDC_A_R2();
        virtual void test2_I_ADDC_A_R2();
        virtual void test3_I_ADDC_A_R2();
	virtual void test4_I_ADDC_A_R2();
        virtual void test1_I_ADDC_A_R3();
        virtual void test2_I_ADDC_A_R3();
        virtual void test3_I_ADDC_A_R3();
	virtual void test4_I_ADDC_A_R3();
        virtual void test1_I_ADDC_A_R4();
        virtual void test2_I_ADDC_A_R4();
        virtual void test3_I_ADDC_A_R4();
	virtual void test4_I_ADDC_A_R4();
        virtual void test1_I_ADDC_A_R5();
        virtual void test2_I_ADDC_A_R5();
        virtual void test3_I_ADDC_A_R5();
	virtual void test4_I_ADDC_A_R5();
        virtual void test1_I_ADDC_A_R6();
        virtual void test2_I_ADDC_A_R6();
        virtual void test3_I_ADDC_A_R6();
	virtual void test4_I_ADDC_A_R6();
        virtual void test1_I_ADDC_A_R7();
        virtual void test2_I_ADDC_A_R7();
        virtual void test3_I_ADDC_A_R7();
	virtual void test4_I_ADDC_A_R7();
	virtual void test1_I_ANL_A_AT_R0();
	virtual void test1_I_ANL_A_AT_R1();
	virtual void test1_I_ANL_A_IMM();
	virtual void test1_I_ANL_A_R0();
	virtual void test1_I_ANL_A_R1();
	virtual void test1_I_ANL_A_R2();
	virtual void test1_I_ANL_A_R3();
	virtual void test1_I_ANL_A_R4();
	virtual void test1_I_ANL_A_R5();
	virtual void test1_I_ANL_A_R6();
	virtual void test1_I_ANL_A_R7();
	virtual void test1_I_ANL_P1_IMM();
	virtual void test1_I_ANL_P2_IMM();
	virtual void test1_I_CALL();
	virtual void test2_I_CALL();
	virtual void test1_I_CLR_A();
	virtual void test1_I_CLR_C();
	virtual void test1_I_CLR_F0();
	virtual void test1_I_CLR_F1();
	virtual void test1_I_CPL_A();
	virtual void test1_I_CPL_C();
	virtual void test1_I_CPL_F0();
	virtual void test1_I_CPL_F1();
	virtual void test1_I_DEC_A();
	virtual void test1_I_DEC_R0();
	virtual void test1_I_DEC_R1();
	virtual void test1_I_DEC_R2();
	virtual void test1_I_DEC_R3();
	virtual void test1_I_DEC_R4();
	virtual void test1_I_DEC_R5();
	virtual void test1_I_DEC_R6();
	virtual void test1_I_DEC_R7();
	virtual void test1_I_DIS_I();
	virtual void test1_I_DIS_TCNTI();
	virtual void test1_I_DJNZ_R0_CODE();
	virtual void test2_I_DJNZ_R0_CODE();
	virtual void test1_I_DJNZ_R1_CODE();
	virtual void test2_I_DJNZ_R1_CODE();
	virtual void test1_I_DJNZ_R2_CODE();
	virtual void test2_I_DJNZ_R2_CODE();
	virtual void test1_I_DJNZ_R3_CODE();
	virtual void test2_I_DJNZ_R3_CODE();
	virtual void test1_I_DJNZ_R4_CODE();
	virtual void test2_I_DJNZ_R4_CODE();
	virtual void test1_I_DJNZ_R5_CODE();
	virtual void test2_I_DJNZ_R5_CODE();
	virtual void test1_I_DJNZ_R6_CODE();
	virtual void test2_I_DJNZ_R6_CODE();
	virtual void test1_I_DJNZ_R7_CODE();
	virtual void test2_I_DJNZ_R7_CODE();
	virtual void test1_I_EN_I();
	virtual void test1_I_EN_TCNTI();
	virtual void test1_I_IN_A_P1();
	virtual void test1_I_IN_A_P2();
	virtual void test1_I_INC_A();
	virtual void test1_I_INC_AT_R0();
	virtual void test1_I_INC_AT_R1();
	virtual void test1_I_INC_R0();
	virtual void test1_I_INC_R1();
	virtual void test1_I_INC_R2();
	virtual void test1_I_INC_R3();
	virtual void test1_I_INC_R4();
	virtual void test1_I_INC_R5();
	virtual void test1_I_INC_R6();
	virtual void test1_I_INC_R7();
	virtual void test1_I_JB0_CODE();
	virtual void test2_I_JB0_CODE();
	virtual void test1_I_JB1_CODE();
	virtual void test2_I_JB1_CODE();
	virtual void test1_I_JB2_CODE();
	virtual void test2_I_JB2_CODE();
	virtual void test1_I_JB3_CODE();
	virtual void test2_I_JB3_CODE();
	virtual void test1_I_JB4_CODE();
	virtual void test2_I_JB4_CODE();
	virtual void test1_I_JB5_CODE();
	virtual void test2_I_JB5_CODE();
	virtual void test1_I_JB6_CODE();
	virtual void test2_I_JB6_CODE();
	virtual void test1_I_JB7_CODE();
	virtual void test2_I_JB7_CODE();
	virtual void test1_I_JC_CODE();
	virtual void test2_I_JC_CODE();
	virtual void test1_I_JF0_CODE();
	virtual void test2_I_JF0_CODE();
	virtual void test1_I_JF1_CODE();
	virtual void test2_I_JF1_CODE();
	virtual void test1_I_JMP_CODE();
	virtual void test2_I_JMP_CODE();
	virtual void test1_I_JMPP_AT_A();
	virtual void test1_I_JNC_CODE();
	virtual void test2_I_JNC_CODE();
	virtual void test1_I_JNI_CODE();
	virtual void test1_I_JNT0_CODE();
	virtual void test1_I_JNT1_CODE();
	virtual void test1_I_JNZ_CODE();
	virtual void test2_I_JNZ_CODE();
	virtual void test1_I_JT0_CODE();
	virtual void test1_I_JT1_CODE();
	virtual void test1_I_JTF_CODE();
	virtual void test2_I_JTF_CODE();
	virtual void test1_I_JZ_CODE();
	virtual void test2_I_JZ_CODE();
	virtual void test1_I_MOV_A_IMM();
	virtual void test1_I_MOV_A_AT_R0();
	virtual void test1_I_MOV_A_AT_R1();
	virtual void test1_I_MOV_A_PSW();
	virtual void test1_I_MOV_A_R0();
	virtual void test1_I_MOV_A_R1();
	virtual void test1_I_MOV_A_R2();
	virtual void test1_I_MOV_A_R3();
	virtual void test1_I_MOV_A_R4();
	virtual void test1_I_MOV_A_R5();
	virtual void test1_I_MOV_A_R6();
	virtual void test1_I_MOV_A_R7();
	virtual void test1_I_MOV_A_T();
	virtual void test1_I_MOV_AT_R0_A();
	virtual void test1_I_MOV_AT_R1_A();
	virtual void test1_I_MOV_AT_R0_IMM();
	virtual void test1_I_MOV_AT_R1_IMM();
	virtual void test1_I_MOV_PSW_A();
	virtual void test2_I_MOV_PSW_A();
	virtual void test1_I_MOV_R0_A();
	virtual void test1_I_MOV_R1_A();
	virtual void test1_I_MOV_R2_A();
	virtual void test1_I_MOV_R3_A();
	virtual void test1_I_MOV_R4_A();
	virtual void test1_I_MOV_R5_A();
	virtual void test1_I_MOV_R6_A();
	virtual void test1_I_MOV_R7_A();
	virtual void test1_I_MOV_R0_IMM();
	virtual void test1_I_MOV_R1_IMM();
	virtual void test1_I_MOV_R2_IMM();
	virtual void test1_I_MOV_R3_IMM();
	virtual void test1_I_MOV_R4_IMM();
	virtual void test1_I_MOV_R5_IMM();
	virtual void test1_I_MOV_R6_IMM();
	virtual void test1_I_MOV_R7_IMM();
	virtual void test1_I_MOV_T_A();
	virtual void test1_I_MOVP_A_AT_A();
	virtual void test1_I_MOVP3_A_AT_A();
	virtual void test1_I_MOVX_A_AT_R0();
	virtual void test1_I_MOVX_A_AT_R1();
	virtual void test1_I_MOVX_AT_R0_A();
	virtual void test1_I_MOVX_AT_R1_A();
	virtual void test1_I_NOP();
	virtual void test1_I_ORL_A_AT_R0();
	virtual void test1_I_ORL_A_AT_R1();
	virtual void test1_I_ORL_A_IMM();
	virtual void test1_I_ORL_A_R0();
	virtual void test1_I_ORL_A_R1();
	virtual void test1_I_ORL_A_R2();
	virtual void test1_I_ORL_A_R3();
	virtual void test1_I_ORL_A_R4();
	virtual void test1_I_ORL_A_R5();
	virtual void test1_I_ORL_A_R6();
	virtual void test1_I_ORL_A_R7();
	virtual void test1_I_ORL_P1_IMM();
	virtual void test1_I_ORL_P2_IMM();
	virtual void test1_I_OUTL_P1_A();
	virtual void test1_I_OUTL_P2_A();
	virtual void test1_I_RET();
	virtual void test1_I_RETR();
	virtual void test1_I_RL_A();
	virtual void test1_I_RLC_A();
	virtual void test2_I_RLC_A();
	virtual void test1_I_RR_A();
	virtual void test1_I_RRC_A();
	virtual void test2_I_RRC_A();
	virtual void test1_I_SEL_MB0();
	virtual void test1_I_SEL_MB1();
	virtual void test1_I_SEL_RB0();
	virtual void test1_I_STOP_TCNT();
	virtual void test1_I_STRT_T();
	virtual void test1_I_SWAP_A();
	virtual void test1_I_XCH_A_AT_R0();
	virtual void test1_I_XCH_A_AT_R1();
	virtual void test1_I_XCH_A_R0();
	virtual void test1_I_XCH_A_R1();
	virtual void test1_I_XCH_A_R2();
	virtual void test1_I_XCH_A_R3();
	virtual void test1_I_XCH_A_R4();
	virtual void test1_I_XCH_A_R5();
	virtual void test1_I_XCH_A_R6();
	virtual void test1_I_XCH_A_R7();
	virtual void test1_I_XRL_A_AT_R0();
	virtual void test1_I_XRL_A_AT_R1();
	virtual void test1_I_XRL_A_IMM();
	virtual void test1_I_XRL_A_R0();
	virtual void test1_I_XRL_A_R1();
	virtual void test1_I_XRL_A_R2();
	virtual void test1_I_XRL_A_R3();
	virtual void test1_I_XRL_A_R4();
	virtual void test1_I_XRL_A_R5();
	virtual void test1_I_XRL_A_R6();
	virtual void test1_I_XRL_A_R7();

	CPU8040 m_CPU8040;
	ROMMgmtMock m_ROMMgmtMock;
	WD1772Mock m_WD1772Mock;
	SerialMock m_SerialMock;
};
}
#endif
