// management of WD1772 data, mockup

#ifndef __XATREMU_WD1772_MOCK__
#define __XATREMU_WD1772_MOCK__

#include "wd1772_base.h"

namespace xatremu
{
class WD1772Mock : public WD1772Base
{
public:
	WD1772Mock();
	virtual ~WD1772Mock();
	virtual void ResetWD1772();
	virtual void ChooseDoubleDensity(bool doubleDensity);
	virtual void MasterReset();
	virtual void ChooseRegister(unsigned char reg);
	virtual void ChooseReadRegisters(bool readRegs);
	virtual void ChooseSide(bool side);
	virtual bool SetImage(char* imageName);
	virtual void Choose288RPM(bool rpm288);
        virtual bool GetIntRq();
        virtual bool StateT1Line(); //data request line
        virtual unsigned char ByteFromWD1772();
        virtual void ByteToWD1772(unsigned char myByte);

private:
	bool m_MasterResetOccurred;	//for check if method was called
	unsigned char m_WD1772Byte;	//Get/Set at any "address"
/*
	bool m_IsDoubleDensity;
	unsigned char m_SelectedRegister; // which address (0-3) is selected
	bool m_SelectRegsForRead;	// true - read, false - write
	bool m_IsDiskSide1;	//false: side0, true: side1
	unsigned char m_CurrentTrack; //0-39
	bool m_Is288rpm;	// for compatibility, create a WD1772 for 288RPM too
	unsigned short int m_EncodedBytesPerTrack; //3255 for FM as standard

	//formula: (is288rpm ? 0.208333333 : 0.2) * 8333333.333 / bytesPerTrack
	unsigned short m_CpuCyclesToNextEncodedByteOfTrack;
*/	
	friend class testCPU8040;
};
}
#endif
